﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DAL.Models
{
    public class Subject : IEntity
    {
        [Key]
        public int Id { get; set; }

        public string Name { get; set; }

        public int ClassroomId { get; set; }

        [ForeignKey(nameof(ClassroomId))]
        public virtual Classroom Classroom { get; set; }

        [NotMapped]
        public string TableName { get; } = nameof(SchoolDBContext.Subjects);
    }
}
